diff --git a/drivers/iommu/iommufd/io_pagetable.c b/drivers/iommu/iommufd/io_pagetable.c
index 05fd9d3abf1b..b4b75663d7cf 100644
--- a/drivers/iommu/iommufd/io_pagetable.c
+++ b/drivers/iommu/iommufd/io_pagetable.c
@@ -222,7 +222,7 @@ static int iopt_insert_area(struct io_pagetable *iopt, struct iopt_area *area,
 	return 0;
 }
 
-static struct iopt_area *iopt_area_alloc(void)
+struct iopt_area *iopt_area_alloc(void)
 {
 	struct iopt_area *area;
 
diff --git a/drivers/iommu/iommufd/iommufd_private.h b/drivers/iommu/iommufd/iommufd_private.h
index ad8d180269bd..94612cec2814 100644
--- a/drivers/iommu/iommufd/iommufd_private.h
+++ b/drivers/iommu/iommufd/iommufd_private.h
@@ -59,6 +59,10 @@ struct io_pagetable {
 	unsigned long iova_alignment;
 };
 
+extern const struct file_operations iommufd_fops;
+int iommufd_fops_open(struct inode *inode, struct file *filp);
+struct iopt_area *iopt_area_alloc(void);
+
 void iopt_init_table(struct io_pagetable *iopt);
 void iopt_destroy_table(struct io_pagetable *iopt);
 int iopt_get_pages(struct io_pagetable *iopt, unsigned long iova,
diff --git a/drivers/iommu/iommufd/main.c b/drivers/iommu/iommufd/main.c
index 21a7e1ad40d1..f78a4cf23741 100644
--- a/drivers/iommu/iommufd/main.c
+++ b/drivers/iommu/iommufd/main.c
@@ -233,7 +233,7 @@ static int iommufd_destroy(struct iommufd_ucmd *ucmd)
 	return iommufd_object_remove(ucmd->ictx, NULL, cmd->id, 0);
 }
 
-static int iommufd_fops_open(struct inode *inode, struct file *filp)
+int iommufd_fops_open(struct inode *inode, struct file *filp)
 {
 	struct iommufd_ctx *ictx;
 
@@ -473,7 +473,7 @@ static long iommufd_fops_ioctl(struct file *filp, unsigned int cmd,
 	return ret;
 }
 
-static const struct file_operations iommufd_fops = {
+const struct file_operations iommufd_fops = {
 	.owner = THIS_MODULE,
 	.open = iommufd_fops_open,
 	.release = iommufd_fops_release,
diff --git a/drivers/iommu/iommufd/serialise.c b/drivers/iommu/iommufd/serialise.c
index 7f2e7b1eda13..9519969bd201 100644
--- a/drivers/iommu/iommufd/serialise.c
+++ b/drivers/iommu/iommufd/serialise.c
@@ -1,5 +1,7 @@
 // SPDX-License-Identifier: GPL-2.0-only
 
+#include <linux/anon_inodes.h>
+#include <linux/fdtable.h>
 #include <linux/kexec.h>
 #include <linux/libfdt.h>
 #include "iommufd_private.h"
@@ -97,10 +99,60 @@ int iommufd_serialise_kho(struct notifier_block *self, unsigned long cmd,
 	}
 }
 
+static int rehydrate_iommufd(char *iommufd_name)
+{
+	struct file *file;
+	int fd;
+	int off;
+	struct iommufd_ctx *ictx;
+	struct files_struct *files = current->files;  // Current process's files_struct
+	const void *fdt = kho_get_fdt();
+	char kho_path[42];
+
+	fd = anon_inode_getfd("iommufd", &iommufd_fops, NULL, O_RDWR);
+	if (fd < 0)
+		return fd;
+	file = files_lookup_fd_raw(files, fd);
+	iommufd_fops_open(NULL, file);
+	ictx = file->private_data;
+
+	snprintf(kho_path, sizeof(kho_path), "/iommufd/iommufds/%s/ioases", iommufd_name);
+	fdt_for_each_subnode(off, fdt, fdt_path_offset(fdt, kho_path)) {
+	    struct iommufd_ioas *ioas;
+	    int range_off;
+
+	    ioas = iommufd_ioas_alloc(ictx);
+	    iommufd_object_finalize(ictx, &ioas->obj);
+
+	    fdt_for_each_subnode(range_off, fdt, off) {
+		    const unsigned long *iova_start, *iova_len;
+		    const int *iommu_prot;
+		    int len;
+		    struct iopt_area *area = iopt_area_alloc();
+
+		    iova_start = fdt_getprop(fdt, range_off, "iova-start", &len);
+		    iova_len = fdt_getprop(fdt, range_off, "iova-len", &len);
+		    iommu_prot = fdt_getprop(fdt, range_off, "iommu-prot", &len);
+
+		    area->iommu_prot = *iommu_prot;
+		    area->node.start = *iova_start;
+		    area->node.last = *iova_start + *iova_len - 1;
+		    interval_tree_insert(&area->node, &ioas->iopt.area_itree);
+	    }
+	    /* TODO: restore link from ioas to hwpt. */
+	}
+
+	return fd;
+}
+
 static ssize_t iommufd_show(struct kobject *kobj, struct kobj_attribute *attr,
 	char *buf)
 {
-	return 0;
+	char fd_str[10];
+	ssize_t len;
+
+	len = snprintf(buf, sizeof(fd_str), "%i\n", rehydrate_iommufd("1"));
+	return len;
 }
 
 static struct kobj_attribute persisted_attr =